package org.processmining.xeslite.plugin;

import java.io.InputStream;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.xeslite.external.XFactoryExternalStore;

/**
 * Open XES log using a buffered implementation {@link XFactoryExternalStore} for
 * the attributes of all XES objects. In this implementation all attributes are
 * immutable. Therefore, it does not support the MXML parser, which tries to
 * change the values of attributes after creation.
 * 
 * @author F. Mannhardt
 * 
 */
@Plugin(name = "Open XES Log File (Disk-buffered by MapDB, sequential access) EXPERIMENTAL", parameterLabels = { "Filename" }, returnLabels = { "Log (single process)" }, returnTypes = { XLog.class })
@UIImportPlugin(description = "ProM log files (Disk-buffered by MapDB, sequential access) EXPERIMENTAL", extensions = { "gz", "zip", "xes", "xez" })
public class OpenLogFileDiskSequentialAccessImplPlugin extends OpenLogFileLitePlugin {

	@Override
	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		XFactoryExternalStore factory = new XFactoryExternalStore.MapDBDiskSequentialAccessImpl();
		Object importFromStream = importFromStream(context, input, filename, fileSizeInBytes, factory);
		factory.commit();
		return importFromStream;
	}

}
